# abdm-gateway
Gateway is the hub that routes/orchestrates the interaction between consent managers and API bridges. There are 5 categories of APIs; discovery, link, consent flow, data flow and  monitoring. To reflect the consumers of APIs, the above apis are also categorized under cm facing, hiu facing and hip facing


This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.5
- Package version: 1.0.0
- Generator version: 7.5.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import abdm_gateway
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import abdm_gateway
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import abdm_gateway
from abdm_gateway.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://dev.abdm.gov.in/gateway
# See configuration.py for a list of all supported configuration parameters.
configuration = abdm_gateway.Configuration(
    host = "https://dev.abdm.gov.in/gateway"
)



# Enter a context with an instance of the API client
with abdm_gateway.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = abdm_gateway.CmFacingApi(api_client)
    authorization = 'authorization_example' # str | Access token which was issued after successful login with gateway auth server.
    x_hip_id = 'x_hip_id_example' # str | Identifier of the health information provider to which the request was intended.
    patient_discovery_request = abdm_gateway.PatientDiscoveryRequest() # PatientDiscoveryRequest | 

    try:
        # Discover patient's accounts
        api_instance.v05_care_contexts_discover_post(authorization, x_hip_id, patient_discovery_request)
    except ApiException as e:
        print("Exception when calling CmFacingApi->v05_care_contexts_discover_post: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://dev.abdm.gov.in/gateway*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*CmFacingApi* | [**v05_care_contexts_discover_post**](docs/CmFacingApi.md#v05_care_contexts_discover_post) | **POST** /v0.5/care-contexts/discover | Discover patient&#39;s accounts
*CmFacingApi* | [**v05_care_contexts_on_discover_post**](docs/CmFacingApi.md#v05_care_contexts_on_discover_post) | **POST** /v0.5/care-contexts/on-discover | Response to patient&#39;s account discovery request
*CmFacingApi* | [**v05_consent_requests_on_init_post**](docs/CmFacingApi.md#v05_consent_requests_on_init_post) | **POST** /v0.5/consent-requests/on-init | Response to consent request
*CmFacingApi* | [**v05_consent_requests_on_status_post**](docs/CmFacingApi.md#v05_consent_requests_on_status_post) | **POST** /v0.5/consent-requests/on-status | Result of consent request status
*CmFacingApi* | [**v05_consents_hip_notify_post**](docs/CmFacingApi.md#v05_consents_hip_notify_post) | **POST** /v0.5/consents/hip/notify | Consent notification
*CmFacingApi* | [**v05_consents_hiu_notify_post**](docs/CmFacingApi.md#v05_consents_hiu_notify_post) | **POST** /v0.5/consents/hiu/notify | Consent notification
*CmFacingApi* | [**v05_consents_on_fetch_post**](docs/CmFacingApi.md#v05_consents_on_fetch_post) | **POST** /v0.5/consents/on-fetch | Result of fetch request for a consent artefact
*CmFacingApi* | [**v05_health_information_cm_on_request_post**](docs/CmFacingApi.md#v05_health_information_cm_on_request_post) | **POST** /v0.5/health-information/cm/on-request | Health information data request
*CmFacingApi* | [**v05_health_information_hip_request_post**](docs/CmFacingApi.md#v05_health_information_hip_request_post) | **POST** /v0.5/health-information/hip/request | Health information data request
*CmFacingApi* | [**v05_links_context_on_notify_post**](docs/CmFacingApi.md#v05_links_context_on_notify_post) | **POST** /v0.5/links/context/on-notify | Acknowledgement sent by Consent Manager to HIP for data notification.
*CmFacingApi* | [**v05_links_link_confirm_post**](docs/CmFacingApi.md#v05_links_link_confirm_post) | **POST** /v0.5/links/link/confirm | Token submission by Consent Manager for link confirmation
*CmFacingApi* | [**v05_links_link_init_post**](docs/CmFacingApi.md#v05_links_link_init_post) | **POST** /v0.5/links/link/init | Link patient&#39;s care contexts
*CmFacingApi* | [**v05_links_link_on_add_contexts_post**](docs/CmFacingApi.md#v05_links_link_on_add_contexts_post) | **POST** /v0.5/links/link/on-add-contexts | callback API for HIP initiated patient linking /link/add-context
*CmFacingApi* | [**v05_patients_on_find_post**](docs/CmFacingApi.md#v05_patients_on_find_post) | **POST** /v0.5/patients/on-find | Identification result for a consent-manager user-id
*CmFacingApi* | [**v05_patients_profile_share_post**](docs/CmFacingApi.md#v05_patients_profile_share_post) | **POST** /v0.5/patients/profile/share | Share patient profile details
*CmFacingApi* | [**v05_patients_sms_on_notify_post**](docs/CmFacingApi.md#v05_patients_sms_on_notify_post) | **POST** /v0.5/patients/sms/on-notify | Acknowledgment response for SMS notification sent to patient by HIP
*CmFacingApi* | [**v05_patients_status_notify_post**](docs/CmFacingApi.md#v05_patients_status_notify_post) | **POST** /v0.5/patients/status/notify | Notification sent by Consent MAnager
*CmFacingApi* | [**v05_subscription_requests_cm_on_init_post**](docs/CmFacingApi.md#v05_subscription_requests_cm_on_init_post) | **POST** /v0.5/subscription-requests/cm/on-init | callback API for the /subscription-requests/cm/init to notify a HIU on acceptance/acknowledgement of the request for subscription.
*CmFacingApi* | [**v05_subscription_requests_hiu_notify_post**](docs/CmFacingApi.md#v05_subscription_requests_hiu_notify_post) | **POST** /v0.5/subscription-requests/hiu/notify | Notification for subscription grant/deny/revoke
*CmFacingApi* | [**v05_subscriptions_hiu_notify_post**](docs/CmFacingApi.md#v05_subscriptions_hiu_notify_post) | **POST** /v0.5/subscriptions/hiu/notify | Notification to HIU on basis of a granted subscription
*CmFacingApi* | [**v05_users_auth_notify_post**](docs/CmFacingApi.md#v05_users_auth_notify_post) | **POST** /v0.5/users/auth/notify | notification API in case of DIRECT mode of authentication by the CM
*CmFacingApi* | [**v05_users_auth_on_confirm_post**](docs/CmFacingApi.md#v05_users_auth_on_confirm_post) | **POST** /v0.5/users/auth/on-confirm | callback API for /auth/confirm (in case of MEDIATED auth) to confirm user authentication or not
*CmFacingApi* | [**v05_users_auth_on_fetch_modes_post**](docs/CmFacingApi.md#v05_users_auth_on_fetch_modes_post) | **POST** /v0.5/users/auth/on-fetch-modes | Identification result for a consent-manager user-id
*CmFacingApi* | [**v05_users_auth_on_init_post**](docs/CmFacingApi.md#v05_users_auth_on_init_post) | **POST** /v0.5/users/auth/on-init | Response to user authentication initialization from HIP
*ConsentFlowApi* | [**v05_consent_requests_init_post**](docs/ConsentFlowApi.md#v05_consent_requests_init_post) | **POST** /v0.5/consent-requests/init | Create consent request
*ConsentFlowApi* | [**v05_consent_requests_on_init_post**](docs/ConsentFlowApi.md#v05_consent_requests_on_init_post) | **POST** /v0.5/consent-requests/on-init | Response to consent request
*ConsentFlowApi* | [**v05_consent_requests_on_status_post**](docs/ConsentFlowApi.md#v05_consent_requests_on_status_post) | **POST** /v0.5/consent-requests/on-status | Result of consent request status
*ConsentFlowApi* | [**v05_consent_requests_status_post**](docs/ConsentFlowApi.md#v05_consent_requests_status_post) | **POST** /v0.5/consent-requests/status | Get consent request status
*ConsentFlowApi* | [**v05_consents_fetch_post**](docs/ConsentFlowApi.md#v05_consents_fetch_post) | **POST** /v0.5/consents/fetch | Get consent artefact
*ConsentFlowApi* | [**v05_consents_hip_notify_post**](docs/ConsentFlowApi.md#v05_consents_hip_notify_post) | **POST** /v0.5/consents/hip/notify | Consent notification
*ConsentFlowApi* | [**v05_consents_hip_on_notify_post**](docs/ConsentFlowApi.md#v05_consents_hip_on_notify_post) | **POST** /v0.5/consents/hip/on-notify | Consent notification
*ConsentFlowApi* | [**v05_consents_hiu_notify_post**](docs/ConsentFlowApi.md#v05_consents_hiu_notify_post) | **POST** /v0.5/consents/hiu/notify | Consent notification
*ConsentFlowApi* | [**v05_consents_hiu_on_notify_post**](docs/ConsentFlowApi.md#v05_consents_hiu_on_notify_post) | **POST** /v0.5/consents/hiu/on-notify | Consent notification
*ConsentFlowApi* | [**v05_consents_on_fetch_post**](docs/ConsentFlowApi.md#v05_consents_on_fetch_post) | **POST** /v0.5/consents/on-fetch | Result of fetch request for a consent artefact
*DataFlowApi* | [**v05_health_information_cm_on_request_post**](docs/DataFlowApi.md#v05_health_information_cm_on_request_post) | **POST** /v0.5/health-information/cm/on-request | Health information data request
*DataFlowApi* | [**v05_health_information_cm_request_post**](docs/DataFlowApi.md#v05_health_information_cm_request_post) | **POST** /v0.5/health-information/cm/request | Health information data request
*DataFlowApi* | [**v05_health_information_hip_on_request_post**](docs/DataFlowApi.md#v05_health_information_hip_on_request_post) | **POST** /v0.5/health-information/hip/on-request | Health information data request
*DataFlowApi* | [**v05_health_information_hip_request_post**](docs/DataFlowApi.md#v05_health_information_hip_request_post) | **POST** /v0.5/health-information/hip/request | Health information data request
*DataFlowApi* | [**v05_health_information_notify_post**](docs/DataFlowApi.md#v05_health_information_notify_post) | **POST** /v0.5/health-information/notify | Notifications corresponding to events during data flow
*DiscoveryApi* | [**v05_care_contexts_discover_post**](docs/DiscoveryApi.md#v05_care_contexts_discover_post) | **POST** /v0.5/care-contexts/discover | Discover patient&#39;s accounts
*DiscoveryApi* | [**v05_care_contexts_on_discover_post**](docs/DiscoveryApi.md#v05_care_contexts_on_discover_post) | **POST** /v0.5/care-contexts/on-discover | Response to patient&#39;s account discovery request
*HipFacingApi* | [**v05_consents_hip_on_notify_post**](docs/HipFacingApi.md#v05_consents_hip_on_notify_post) | **POST** /v0.5/consents/hip/on-notify | Consent notification
*HipFacingApi* | [**v05_health_information_hip_on_request_post**](docs/HipFacingApi.md#v05_health_information_hip_on_request_post) | **POST** /v0.5/health-information/hip/on-request | Health information data request
*HipFacingApi* | [**v05_health_information_notify_post**](docs/HipFacingApi.md#v05_health_information_notify_post) | **POST** /v0.5/health-information/notify | Notifications corresponding to events during data flow
*HipFacingApi* | [**v05_links_context_notify_post**](docs/HipFacingApi.md#v05_links_context_notify_post) | **POST** /v0.5/links/context/notify | This API is meant to be called by HIPs when there is new health data generated for a patient, against a care context that is already linked to patient&#39;s ABDM account.
*HipFacingApi* | [**v05_links_link_add_contexts_post**](docs/HipFacingApi.md#v05_links_link_add_contexts_post) | **POST** /v0.5/links/link/add-contexts | API for HIP initiated care-context linking for patient
*HipFacingApi* | [**v05_links_link_on_confirm_post**](docs/HipFacingApi.md#v05_links_link_on_confirm_post) | **POST** /v0.5/links/link/on-confirm | Token authenticated by HIP, indicating completion of linkage of care-contexts
*HipFacingApi* | [**v05_links_link_on_init_post**](docs/HipFacingApi.md#v05_links_link_on_init_post) | **POST** /v0.5/links/link/on-init | Response to patient&#39;s care context link request
*HipFacingApi* | [**v05_patients_sms_notify_post**](docs/HipFacingApi.md#v05_patients_sms_notify_post) | **POST** /v0.5/patients/sms/notify | API for HIP to send SMS notifications to patients
*HipFacingApi* | [**v05_patients_status_on_notify_post**](docs/HipFacingApi.md#v05_patients_status_on_notify_post) | **POST** /v0.5/patients/status/on-notify | Acknowledgment by HIP/HIU
*HipFacingApi* | [**v05_users_auth_confirm_post**](docs/HipFacingApi.md#v05_users_auth_confirm_post) | **POST** /v0.5/users/auth/confirm | Confirmation request sending token, otp or other authentication details from HIP/HIU for confirmation
*HipFacingApi* | [**v05_users_auth_fetch_modes_post**](docs/HipFacingApi.md#v05_users_auth_fetch_modes_post) | **POST** /v0.5/users/auth/fetch-modes | Get a patient&#39;s authentication modes relevant to specified purpose
*HipFacingApi* | [**v05_users_auth_init_post**](docs/HipFacingApi.md#v05_users_auth_init_post) | **POST** /v0.5/users/auth/init | Initialize authentication from HIP
*HipFacingApi* | [**v05_users_auth_on_notify_post**](docs/HipFacingApi.md#v05_users_auth_on_notify_post) | **POST** /v0.5/users/auth/on-notify | callback API by HIU/HIPs as acknowledgement of auth notification
*HiuFacingApi* | [**v05_consent_requests_init_post**](docs/HiuFacingApi.md#v05_consent_requests_init_post) | **POST** /v0.5/consent-requests/init | Create consent request
*HiuFacingApi* | [**v05_consent_requests_status_post**](docs/HiuFacingApi.md#v05_consent_requests_status_post) | **POST** /v0.5/consent-requests/status | Get consent request status
*HiuFacingApi* | [**v05_consents_fetch_post**](docs/HiuFacingApi.md#v05_consents_fetch_post) | **POST** /v0.5/consents/fetch | Get consent artefact
*HiuFacingApi* | [**v05_consents_hiu_on_notify_post**](docs/HiuFacingApi.md#v05_consents_hiu_on_notify_post) | **POST** /v0.5/consents/hiu/on-notify | Consent notification
*HiuFacingApi* | [**v05_health_information_cm_request_post**](docs/HiuFacingApi.md#v05_health_information_cm_request_post) | **POST** /v0.5/health-information/cm/request | Health information data request
*HiuFacingApi* | [**v05_health_information_notify_post**](docs/HiuFacingApi.md#v05_health_information_notify_post) | **POST** /v0.5/health-information/notify | Notifications corresponding to events during data flow
*HiuFacingApi* | [**v05_patients_find_post**](docs/HiuFacingApi.md#v05_patients_find_post) | **POST** /v0.5/patients/find | Identify a patient by her consent-manager user-id
*HiuFacingApi* | [**v05_patients_status_on_notify_post**](docs/HiuFacingApi.md#v05_patients_status_on_notify_post) | **POST** /v0.5/patients/status/on-notify | Acknowledgment by HIP/HIU
*HiuFacingApi* | [**v05_subscription_requests_cm_init_post**](docs/HiuFacingApi.md#v05_subscription_requests_cm_init_post) | **POST** /v0.5/subscription-requests/cm/init | Request for subscription
*HiuFacingApi* | [**v05_subscription_requests_hiu_on_notify_post**](docs/HiuFacingApi.md#v05_subscription_requests_hiu_on_notify_post) | **POST** /v0.5/subscription-requests/hiu/on-notify | Callback API for /subscription-requests/hiu/notify to acknowledge receipt of notification.
*HiuFacingApi* | [**v05_subscriptions_hiu_on_notify_post**](docs/HiuFacingApi.md#v05_subscriptions_hiu_on_notify_post) | **POST** /v0.5/subscriptions/hiu/on-notify | Callback API for /subscriptions/hiu/notify to acknowledge receipt of notification.
*HiuFacingApi* | [**v05_users_auth_confirm_post**](docs/HiuFacingApi.md#v05_users_auth_confirm_post) | **POST** /v0.5/users/auth/confirm | Confirmation request sending token, otp or other authentication details from HIP/HIU for confirmation
*HiuFacingApi* | [**v05_users_auth_fetch_modes_post**](docs/HiuFacingApi.md#v05_users_auth_fetch_modes_post) | **POST** /v0.5/users/auth/fetch-modes | Get a patient&#39;s authentication modes relevant to specified purpose
*HiuFacingApi* | [**v05_users_auth_init_post**](docs/HiuFacingApi.md#v05_users_auth_init_post) | **POST** /v0.5/users/auth/init | Initialize authentication from HIP
*HiuFacingApi* | [**v05_users_auth_on_notify_post**](docs/HiuFacingApi.md#v05_users_auth_on_notify_post) | **POST** /v0.5/users/auth/on-notify | callback API by HIU/HIPs as acknowledgement of auth notification
*IdentificationApi* | [**v05_patients_find_post**](docs/IdentificationApi.md#v05_patients_find_post) | **POST** /v0.5/patients/find | Identify a patient by her consent-manager user-id
*IdentificationApi* | [**v05_patients_on_find_post**](docs/IdentificationApi.md#v05_patients_on_find_post) | **POST** /v0.5/patients/on-find | Identification result for a consent-manager user-id
*LinkApi* | [**v05_links_context_notify_post**](docs/LinkApi.md#v05_links_context_notify_post) | **POST** /v0.5/links/context/notify | This API is meant to be called by HIPs when there is new health data generated for a patient, against a care context that is already linked to patient&#39;s ABDM account.
*LinkApi* | [**v05_links_context_on_notify_post**](docs/LinkApi.md#v05_links_context_on_notify_post) | **POST** /v0.5/links/context/on-notify | Acknowledgement sent by Consent Manager to HIP for data notification.
*LinkApi* | [**v05_links_link_add_contexts_post**](docs/LinkApi.md#v05_links_link_add_contexts_post) | **POST** /v0.5/links/link/add-contexts | API for HIP initiated care-context linking for patient
*LinkApi* | [**v05_links_link_confirm_post**](docs/LinkApi.md#v05_links_link_confirm_post) | **POST** /v0.5/links/link/confirm | Token submission by Consent Manager for link confirmation
*LinkApi* | [**v05_links_link_init_post**](docs/LinkApi.md#v05_links_link_init_post) | **POST** /v0.5/links/link/init | Link patient&#39;s care contexts
*LinkApi* | [**v05_links_link_on_add_contexts_post**](docs/LinkApi.md#v05_links_link_on_add_contexts_post) | **POST** /v0.5/links/link/on-add-contexts | callback API for HIP initiated patient linking /link/add-context
*LinkApi* | [**v05_links_link_on_confirm_post**](docs/LinkApi.md#v05_links_link_on_confirm_post) | **POST** /v0.5/links/link/on-confirm | Token authenticated by HIP, indicating completion of linkage of care-contexts
*LinkApi* | [**v05_links_link_on_init_post**](docs/LinkApi.md#v05_links_link_on_init_post) | **POST** /v0.5/links/link/on-init | Response to patient&#39;s care context link request
*MonitoringApi* | [**v05_heartbeat_get**](docs/MonitoringApi.md#v05_heartbeat_get) | **GET** /v0.5/heartbeat | Informs about server status
*PatientNotificationApi* | [**v05_patients_sms_notify_post**](docs/PatientNotificationApi.md#v05_patients_sms_notify_post) | **POST** /v0.5/patients/sms/notify | API for HIP to send SMS notifications to patients
*PatientNotificationApi* | [**v05_patients_sms_on_notify_post**](docs/PatientNotificationApi.md#v05_patients_sms_on_notify_post) | **POST** /v0.5/patients/sms/on-notify | Acknowledgment response for SMS notification sent to patient by HIP
*PatientNotificationApi* | [**v05_patients_status_notify_post**](docs/PatientNotificationApi.md#v05_patients_status_notify_post) | **POST** /v0.5/patients/status/notify | Notification sent by Consent MAnager
*PatientNotificationApi* | [**v05_patients_status_on_notify_post**](docs/PatientNotificationApi.md#v05_patients_status_on_notify_post) | **POST** /v0.5/patients/status/on-notify | Acknowledgment by HIP/HIU
*ProfileApi* | [**v05_patients_profile_on_share_post**](docs/ProfileApi.md#v05_patients_profile_on_share_post) | **POST** /v0.5/patients/profile/on-share | Response to patient&#39;s share profile request
*ProfileApi* | [**v05_patients_profile_share_post**](docs/ProfileApi.md#v05_patients_profile_share_post) | **POST** /v0.5/patients/profile/share | Share patient profile details
*ProfileApi* | [**v10_patients_profile_on_share_post**](docs/ProfileApi.md#v10_patients_profile_on_share_post) | **POST** /v1.0/patients/profile/on-share | Response to patient&#39;s share profile request
*ProfileApi* | [**v10_patients_profile_share_post**](docs/ProfileApi.md#v10_patients_profile_share_post) | **POST** /v1.0/patients/profile/share | Share patient profile details
*ServicesApi* | [**v05_hi_services_service_id_get**](docs/ServicesApi.md#v05_hi_services_service_id_get) | **GET** /v0.5/hi-services/{service-id} | Get bridge service details/profile by the serviceId provided.
*SessionsApi* | [**v05_certs_get**](docs/SessionsApi.md#v05_certs_get) | **GET** /v0.5/certs | Get certs for JWT verification
*SessionsApi* | [**v05_sessions_post**](docs/SessionsApi.md#v05_sessions_post) | **POST** /v0.5/sessions | Get access token
*SessionsApi* | [**v05_well_known_openid_configuration_get**](docs/SessionsApi.md#v05_well_known_openid_configuration_get) | **GET** /v0.5/.well-known/openid-configuration | Get openid configuration
*SubscriptionsApi* | [**v05_subscription_requests_cm_init_post**](docs/SubscriptionsApi.md#v05_subscription_requests_cm_init_post) | **POST** /v0.5/subscription-requests/cm/init | Request for subscription
*SubscriptionsApi* | [**v05_subscription_requests_cm_on_init_post**](docs/SubscriptionsApi.md#v05_subscription_requests_cm_on_init_post) | **POST** /v0.5/subscription-requests/cm/on-init | callback API for the /subscription-requests/cm/init to notify a HIU on acceptance/acknowledgement of the request for subscription.
*SubscriptionsApi* | [**v05_subscription_requests_hiu_notify_post**](docs/SubscriptionsApi.md#v05_subscription_requests_hiu_notify_post) | **POST** /v0.5/subscription-requests/hiu/notify | Notification for subscription grant/deny/revoke
*SubscriptionsApi* | [**v05_subscription_requests_hiu_on_notify_post**](docs/SubscriptionsApi.md#v05_subscription_requests_hiu_on_notify_post) | **POST** /v0.5/subscription-requests/hiu/on-notify | Callback API for /subscription-requests/hiu/notify to acknowledge receipt of notification.
*SubscriptionsApi* | [**v05_subscriptions_hiu_notify_post**](docs/SubscriptionsApi.md#v05_subscriptions_hiu_notify_post) | **POST** /v0.5/subscriptions/hiu/notify | Notification to HIU on basis of a granted subscription
*SubscriptionsApi* | [**v05_subscriptions_hiu_on_notify_post**](docs/SubscriptionsApi.md#v05_subscriptions_hiu_on_notify_post) | **POST** /v0.5/subscriptions/hiu/on-notify | Callback API for /subscriptions/hiu/notify to acknowledge receipt of notification.
*UserAuthApi* | [**v05_users_auth_confirm_post**](docs/UserAuthApi.md#v05_users_auth_confirm_post) | **POST** /v0.5/users/auth/confirm | Confirmation request sending token, otp or other authentication details from HIP/HIU for confirmation
*UserAuthApi* | [**v05_users_auth_fetch_modes_post**](docs/UserAuthApi.md#v05_users_auth_fetch_modes_post) | **POST** /v0.5/users/auth/fetch-modes | Get a patient&#39;s authentication modes relevant to specified purpose
*UserAuthApi* | [**v05_users_auth_init_post**](docs/UserAuthApi.md#v05_users_auth_init_post) | **POST** /v0.5/users/auth/init | Initialize authentication from HIP
*UserAuthApi* | [**v05_users_auth_notify_post**](docs/UserAuthApi.md#v05_users_auth_notify_post) | **POST** /v0.5/users/auth/notify | notification API in case of DIRECT mode of authentication by the CM
*UserAuthApi* | [**v05_users_auth_on_confirm_post**](docs/UserAuthApi.md#v05_users_auth_on_confirm_post) | **POST** /v0.5/users/auth/on-confirm | callback API for /auth/confirm (in case of MEDIATED auth) to confirm user authentication or not
*UserAuthApi* | [**v05_users_auth_on_fetch_modes_post**](docs/UserAuthApi.md#v05_users_auth_on_fetch_modes_post) | **POST** /v0.5/users/auth/on-fetch-modes | Identification result for a consent-manager user-id
*UserAuthApi* | [**v05_users_auth_on_init_post**](docs/UserAuthApi.md#v05_users_auth_on_init_post) | **POST** /v0.5/users/auth/on-init | Response to user authentication initialization from HIP
*UserAuthApi* | [**v05_users_auth_on_notify_post**](docs/UserAuthApi.md#v05_users_auth_on_notify_post) | **POST** /v0.5/users/auth/on-notify | callback API by HIU/HIPs as acknowledgement of auth notification


## Documentation For Models

 - [AccessTokenValidity](docs/AccessTokenValidity.md)
 - [AuthConfirmIdentifier](docs/AuthConfirmIdentifier.md)
 - [AuthConfirmIdentifierType](docs/AuthConfirmIdentifierType.md)
 - [AuthMeta](docs/AuthMeta.md)
 - [AuthenticationMode](docs/AuthenticationMode.md)
 - [CareContext](docs/CareContext.md)
 - [CareContextDefinition](docs/CareContextDefinition.md)
 - [CareContextRepresentation](docs/CareContextRepresentation.md)
 - [CertificateOrKeyGetSchema](docs/CertificateOrKeyGetSchema.md)
 - [Certs](docs/Certs.md)
 - [Consent](docs/Consent.md)
 - [ConsentAcknowledgement](docs/ConsentAcknowledgement.md)
 - [ConsentArtefactReference](docs/ConsentArtefactReference.md)
 - [ConsentArtefactResponse](docs/ConsentArtefactResponse.md)
 - [ConsentArtefactResponseConsent](docs/ConsentArtefactResponseConsent.md)
 - [ConsentArtefactResponseConsentConsentDetail](docs/ConsentArtefactResponseConsentConsentDetail.md)
 - [ConsentArtefactResponseConsentConsentDetailConsentManager](docs/ConsentArtefactResponseConsentConsentDetailConsentManager.md)
 - [ConsentFetchRequest](docs/ConsentFetchRequest.md)
 - [ConsentManagerPatientID](docs/ConsentManagerPatientID.md)
 - [ConsentRequest](docs/ConsentRequest.md)
 - [ConsentRequestConsent](docs/ConsentRequestConsent.md)
 - [ConsentRequestConsentHiu](docs/ConsentRequestConsentHiu.md)
 - [ConsentRequestConsentPatient](docs/ConsentRequestConsentPatient.md)
 - [ConsentRequestInitResponse](docs/ConsentRequestInitResponse.md)
 - [ConsentRequestInitResponseConsentRequest](docs/ConsentRequestInitResponseConsentRequest.md)
 - [ConsentRequestStatusRequest](docs/ConsentRequestStatusRequest.md)
 - [ConsentStatus](docs/ConsentStatus.md)
 - [DateRange](docs/DateRange.md)
 - [Endpoint](docs/Endpoint.md)
 - [Error](docs/Error.md)
 - [ErrorResponse](docs/ErrorResponse.md)
 - [EventCategoryDetail](docs/EventCategoryDetail.md)
 - [GatewayPatientStatusNotification](docs/GatewayPatientStatusNotification.md)
 - [HIPConsentNotification](docs/HIPConsentNotification.md)
 - [HIPConsentNotificationNotification](docs/HIPConsentNotificationNotification.md)
 - [HIPConsentNotificationNotificationConsentDetail](docs/HIPConsentNotificationNotificationConsentDetail.md)
 - [HIPConsentNotificationNotificationConsentDetailCareContextsInner](docs/HIPConsentNotificationNotificationConsentDetailCareContextsInner.md)
 - [HIPConsentNotificationNotificationConsentDetailConsentManager](docs/HIPConsentNotificationNotificationConsentDetailConsentManager.md)
 - [HIPConsentNotificationNotificationConsentDetailHip](docs/HIPConsentNotificationNotificationConsentDetailHip.md)
 - [HIPConsentNotificationResponse](docs/HIPConsentNotificationResponse.md)
 - [HIPHIRequest](docs/HIPHIRequest.md)
 - [HIPHealthInformationRequestAcknowledgement](docs/HIPHealthInformationRequestAcknowledgement.md)
 - [HIPHealthInformationRequestAcknowledgementHiRequest](docs/HIPHealthInformationRequestAcknowledgementHiRequest.md)
 - [HIRequest](docs/HIRequest.md)
 - [HIRequestHiRequest](docs/HIRequestHiRequest.md)
 - [HITypeEnum](docs/HITypeEnum.md)
 - [HIUConsentNotificationEvent](docs/HIUConsentNotificationEvent.md)
 - [HIUConsentNotificationEventNotification](docs/HIUConsentNotificationEventNotification.md)
 - [HIUConsentNotificationResponse](docs/HIUConsentNotificationResponse.md)
 - [HIUConsentRequestStatus](docs/HIUConsentRequestStatus.md)
 - [HIUConsentRequestStatusConsentRequest](docs/HIUConsentRequestStatusConsentRequest.md)
 - [HIUHealthInformationRequestResponse](docs/HIUHealthInformationRequestResponse.md)
 - [HIUHealthInformationRequestResponseHiRequest](docs/HIUHealthInformationRequestResponseHiRequest.md)
 - [HIUSubscription](docs/HIUSubscription.md)
 - [HIUSubscriptionContext](docs/HIUSubscriptionContext.md)
 - [HIUSubscriptionEventContent](docs/HIUSubscriptionEventContent.md)
 - [HIUSubscriptionNotification](docs/HIUSubscriptionNotification.md)
 - [HIUSubscriptionNotificationAcknowledgment](docs/HIUSubscriptionNotificationAcknowledgment.md)
 - [HIUSubscriptionNotificationAcknowledgmentAcknowledgement](docs/HIUSubscriptionNotificationAcknowledgmentAcknowledgement.md)
 - [HIUSubscriptionNotificationEvent](docs/HIUSubscriptionNotificationEvent.md)
 - [HIUSubscriptionRequestNotificationAcknowledgement](docs/HIUSubscriptionRequestNotificationAcknowledgement.md)
 - [HIUSubscriptionRequestNotificationAcknowledgementAcknowledgement](docs/HIUSubscriptionRequestNotificationAcknowledgementAcknowledgement.md)
 - [HIUSubscriptionRequestReceipt](docs/HIUSubscriptionRequestReceipt.md)
 - [HealthInformationNotification](docs/HealthInformationNotification.md)
 - [HealthInformationNotificationNotification](docs/HealthInformationNotificationNotification.md)
 - [HealthInformationNotificationNotificationNotifier](docs/HealthInformationNotificationNotificationNotifier.md)
 - [HealthInformationNotificationNotificationStatusNotification](docs/HealthInformationNotificationNotificationStatusNotification.md)
 - [HealthInformationNotificationNotificationStatusNotificationStatusResponsesInner](docs/HealthInformationNotificationNotificationStatusNotificationStatusResponsesInner.md)
 - [HeartbeatResponse](docs/HeartbeatResponse.md)
 - [HipDataNotificationAcknowledgement](docs/HipDataNotificationAcknowledgement.md)
 - [HipDataNotificationRequest](docs/HipDataNotificationRequest.md)
 - [HipDataNotificationRequestNotification](docs/HipDataNotificationRequestNotification.md)
 - [HipDataNotificationRequestNotificationHip](docs/HipDataNotificationRequestNotificationHip.md)
 - [HipDataNotificationRequestNotificationPatient](docs/HipDataNotificationRequestNotificationPatient.md)
 - [Identifier](docs/Identifier.md)
 - [IdentifierType](docs/IdentifierType.md)
 - [KeyMaterial](docs/KeyMaterial.md)
 - [KeyObject](docs/KeyObject.md)
 - [LinkConfirmationRequest](docs/LinkConfirmationRequest.md)
 - [LinkConfirmationRequestConfirmation](docs/LinkConfirmationRequestConfirmation.md)
 - [Location](docs/Location.md)
 - [Meta](docs/Meta.md)
 - [OpenIdConfiguration](docs/OpenIdConfiguration.md)
 - [OrganizationReference](docs/OrganizationReference.md)
 - [OrganizationRepresentation](docs/OrganizationRepresentation.md)
 - [PatientAddress](docs/PatientAddress.md)
 - [PatientAuthConfirmRequest](docs/PatientAuthConfirmRequest.md)
 - [PatientAuthConfirmRequestCredential](docs/PatientAuthConfirmRequestCredential.md)
 - [PatientAuthConfirmResponse](docs/PatientAuthConfirmResponse.md)
 - [PatientAuthConfirmResponseAuth](docs/PatientAuthConfirmResponseAuth.md)
 - [PatientAuthInitRequest](docs/PatientAuthInitRequest.md)
 - [PatientAuthInitRequestQuery](docs/PatientAuthInitRequestQuery.md)
 - [PatientAuthInitResponse](docs/PatientAuthInitResponse.md)
 - [PatientAuthInitResponseAuth](docs/PatientAuthInitResponseAuth.md)
 - [PatientAuthModeQueryRequest](docs/PatientAuthModeQueryRequest.md)
 - [PatientAuthModeQueryRequestQuery](docs/PatientAuthModeQueryRequestQuery.md)
 - [PatientAuthModeQueryRequestQueryRequester](docs/PatientAuthModeQueryRequestQueryRequester.md)
 - [PatientAuthModeQueryResponse](docs/PatientAuthModeQueryResponse.md)
 - [PatientAuthModeQueryResponseAuth](docs/PatientAuthModeQueryResponseAuth.md)
 - [PatientAuthNotification](docs/PatientAuthNotification.md)
 - [PatientAuthNotificationAcknowledgement](docs/PatientAuthNotificationAcknowledgement.md)
 - [PatientAuthNotificationAcknowledgementAcknowledgement](docs/PatientAuthNotificationAcknowledgementAcknowledgement.md)
 - [PatientAuthNotificationAuth](docs/PatientAuthNotificationAuth.md)
 - [PatientAuthPurpose](docs/PatientAuthPurpose.md)
 - [PatientAuthRequester](docs/PatientAuthRequester.md)
 - [PatientCareContextLink](docs/PatientCareContextLink.md)
 - [PatientCareContextLinkPatient](docs/PatientCareContextLinkPatient.md)
 - [PatientCareContextLinkRequest](docs/PatientCareContextLinkRequest.md)
 - [PatientCareContextLinkResponse](docs/PatientCareContextLinkResponse.md)
 - [PatientCareContextLinkResponseAcknowledgement](docs/PatientCareContextLinkResponseAcknowledgement.md)
 - [PatientDemographic](docs/PatientDemographic.md)
 - [PatientDemographicResponse](docs/PatientDemographicResponse.md)
 - [PatientDiscoveryRequest](docs/PatientDiscoveryRequest.md)
 - [PatientDiscoveryRequestPatient](docs/PatientDiscoveryRequestPatient.md)
 - [PatientDiscoveryResult](docs/PatientDiscoveryResult.md)
 - [PatientGender](docs/PatientGender.md)
 - [PatientIdentificationRequest](docs/PatientIdentificationRequest.md)
 - [PatientIdentificationRequestQuery](docs/PatientIdentificationRequestQuery.md)
 - [PatientIdentificationRequestQueryPatient](docs/PatientIdentificationRequestQueryPatient.md)
 - [PatientIdentificationRequestQueryRequester](docs/PatientIdentificationRequestQueryRequester.md)
 - [PatientIdentificationResponse](docs/PatientIdentificationResponse.md)
 - [PatientIdentificationResponsePatient](docs/PatientIdentificationResponsePatient.md)
 - [PatientLinkReferenceRequest](docs/PatientLinkReferenceRequest.md)
 - [PatientLinkReferenceRequestPatient](docs/PatientLinkReferenceRequestPatient.md)
 - [PatientLinkReferenceResult](docs/PatientLinkReferenceResult.md)
 - [PatientLinkReferenceResultLink](docs/PatientLinkReferenceResultLink.md)
 - [PatientLinkResult](docs/PatientLinkResult.md)
 - [PatientLinkResultPatient](docs/PatientLinkResultPatient.md)
 - [PatientRepresentation](docs/PatientRepresentation.md)
 - [PatientSMSNotifcationRequest](docs/PatientSMSNotifcationRequest.md)
 - [PatientSMSNotifcationRequestNotification](docs/PatientSMSNotifcationRequestNotification.md)
 - [PatientSMSNotifcationRequestNotificationHip](docs/PatientSMSNotifcationRequestNotificationHip.md)
 - [PatientSMSNotifcationResponse](docs/PatientSMSNotifcationResponse.md)
 - [PatientStatusNotification](docs/PatientStatusNotification.md)
 - [PatientStatusNotificationNotification](docs/PatientStatusNotificationNotification.md)
 - [PatientStatusNotificationNotificationPatient](docs/PatientStatusNotificationNotificationPatient.md)
 - [Permission](docs/Permission.md)
 - [PermissionDateRange](docs/PermissionDateRange.md)
 - [PermissionFrequency](docs/PermissionFrequency.md)
 - [RequestReference](docs/RequestReference.md)
 - [Requester](docs/Requester.md)
 - [RequesterIdentifier](docs/RequesterIdentifier.md)
 - [ServiceProfileResponse](docs/ServiceProfileResponse.md)
 - [ServiceRole](docs/ServiceRole.md)
 - [SessionRequest](docs/SessionRequest.md)
 - [SessionResponse](docs/SessionResponse.md)
 - [ShareProfileAcknowledgement](docs/ShareProfileAcknowledgement.md)
 - [ShareProfileAcknowledgement1](docs/ShareProfileAcknowledgement1.md)
 - [ShareProfileRequest](docs/ShareProfileRequest.md)
 - [ShareProfileRequest1](docs/ShareProfileRequest1.md)
 - [ShareProfileRequest1Intent](docs/ShareProfileRequest1Intent.md)
 - [ShareProfileRequest1Profile](docs/ShareProfileRequest1Profile.md)
 - [ShareProfileRequestProfile](docs/ShareProfileRequestProfile.md)
 - [ShareProfileRequestProfilePatient](docs/ShareProfileRequestProfilePatient.md)
 - [ShareProfileResult](docs/ShareProfileResult.md)
 - [ShareProfileResult1](docs/ShareProfileResult1.md)
 - [SubscriptionApprovalNotification](docs/SubscriptionApprovalNotification.md)
 - [SubscriptionApprovalNotificationNotification](docs/SubscriptionApprovalNotificationNotification.md)
 - [SubscriptionCategory](docs/SubscriptionCategory.md)
 - [SubscriptionPeriod](docs/SubscriptionPeriod.md)
 - [SubscriptionRequest](docs/SubscriptionRequest.md)
 - [SubscriptionRequestSubscription](docs/SubscriptionRequestSubscription.md)
 - [SubscriptionStatus](docs/SubscriptionStatus.md)
 - [UsePurpose](docs/UsePurpose.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization

Endpoints do not require authorization.


## Author




