# coding: utf-8

"""
    Gateway

    Gateway is the hub that routes/orchestrates the interaction between consent managers and API bridges. There are 5 categories of APIs; discovery, link, consent flow, data flow and  monitoring. To reflect the consumers of APIs, the above apis are also categorized under cm facing, hiu facing and hip facing 

    The version of the OpenAPI document: 0.5
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from abdm_gateway.models.health_information_notification_notification_status_notification_status_responses_inner import HealthInformationNotificationNotificationStatusNotificationStatusResponsesInner
from typing import Optional, Set
from typing_extensions import Self

class HealthInformationNotificationNotificationStatusNotification(BaseModel):
    """
    HealthInformationNotificationNotificationStatusNotification
    """ # noqa: E501
    session_status: StrictStr = Field(alias="sessionStatus")
    hip_id: StrictStr = Field(alias="hipId")
    status_responses: Optional[List[HealthInformationNotificationNotificationStatusNotificationStatusResponsesInner]] = Field(default=None, alias="statusResponses")
    __properties: ClassVar[List[str]] = ["sessionStatus", "hipId", "statusResponses"]

    @field_validator('session_status')
    def session_status_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['TRANSFERRED', 'FAILED']):
            raise ValueError("must be one of enum values ('TRANSFERRED', 'FAILED')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of HealthInformationNotificationNotificationStatusNotification from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in status_responses (list)
        _items = []
        if self.status_responses:
            for _item in self.status_responses:
                if _item:
                    _items.append(_item.to_dict())
            _dict['statusResponses'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of HealthInformationNotificationNotificationStatusNotification from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "sessionStatus": obj.get("sessionStatus"),
            "hipId": obj.get("hipId"),
            "statusResponses": [HealthInformationNotificationNotificationStatusNotificationStatusResponsesInner.from_dict(_item) for _item in obj["statusResponses"]] if obj.get("statusResponses") is not None else None
        })
        return _obj


